checkout: pass "struct checkout_opts *" as const pointer
[git/jnareb-git.git] / t / test-lib-functions.sh
blob9bc57d27e961720c98f75f95ab3186723e77f88b
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # The semantics of the editor variables are that of invoking
19 # sh -c "$EDITOR \"$@\"" files ...
21 # If our trash directory contains shell metacharacters, they will be
22 # interpreted if we just set $EDITOR directly, so do a little dance with
23 # environment variables to work around this.
25 # In particular, quoting isn't enough, as the path may contain the same quote
26 # that we're using.
27 test_set_editor () {
28 FAKE_EDITOR="$1"
29 export FAKE_EDITOR
30 EDITOR='"$FAKE_EDITOR"'
31 export EDITOR
34 test_decode_color () {
35 awk '
36 function name(n) {
37 if (n == 0) return "RESET";
38 if (n == 1) return "BOLD";
39 if (n == 30) return "BLACK";
40 if (n == 31) return "RED";
41 if (n == 32) return "GREEN";
42 if (n == 33) return "YELLOW";
43 if (n == 34) return "BLUE";
44 if (n == 35) return "MAGENTA";
45 if (n == 36) return "CYAN";
46 if (n == 37) return "WHITE";
47 if (n == 40) return "BLACK";
48 if (n == 41) return "BRED";
49 if (n == 42) return "BGREEN";
50 if (n == 43) return "BYELLOW";
51 if (n == 44) return "BBLUE";
52 if (n == 45) return "BMAGENTA";
53 if (n == 46) return "BCYAN";
54 if (n == 47) return "BWHITE";
57 while (match($0, /\033\[[0-9;]*m/) != 0) {
58 printf "%s<", substr($0, 1, RSTART-1);
59 codes = substr($0, RSTART+2, RLENGTH-3);
60 if (length(codes) == 0)
61 printf "%s", name(0)
62 else {
63 n = split(codes, ary, ";");
64 sep = "";
65 for (i = 1; i <= n; i++) {
66 printf "%s%s", sep, name(ary[i]);
67 sep = ";"
70 printf ">";
71 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
73 print
78 nul_to_q () {
79 "$PERL_PATH" -pe 'y/\000/Q/'
82 q_to_nul () {
83 "$PERL_PATH" -pe 'y/Q/\000/'
86 q_to_cr () {
87 tr Q '\015'
90 q_to_tab () {
91 tr Q '\011'
94 append_cr () {
95 sed -e 's/$/Q/' | tr Q '\015'
98 remove_cr () {
99 tr '\015' Q | sed -e 's/Q$//'
102 # In some bourne shell implementations, the "unset" builtin returns
103 # nonzero status when a variable to be unset was not set in the first
104 # place.
106 # Use sane_unset when that should not be considered an error.
108 sane_unset () {
109 unset "$@"
110 return 0
113 test_tick () {
114 if test -z "${test_tick+set}"
115 then
116 test_tick=1112911993
117 else
118 test_tick=$(($test_tick + 60))
120 GIT_COMMITTER_DATE="$test_tick -0700"
121 GIT_AUTHOR_DATE="$test_tick -0700"
122 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
125 # Stop execution and start a shell. This is useful for debugging tests and
126 # only makes sense together with "-v".
128 # Be sure to remove all invocations of this command before submitting.
130 test_pause () {
131 if test "$verbose" = t; then
132 "$SHELL_PATH" <&6 >&3 2>&4
133 else
134 error >&5 "test_pause requires --verbose"
138 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
140 # This will commit a file with the given contents and the given commit
141 # message. It will also add a tag with <message> as name.
143 # Both <file> and <contents> default to <message>.
145 test_commit () {
146 notick= &&
147 if test "z$1" = "z--notick"
148 then
149 notick=yes
150 shift
151 fi &&
152 file=${2:-"$1.t"} &&
153 echo "${3-$1}" > "$file" &&
154 git add "$file" &&
155 if test -z "$notick"
156 then
157 test_tick
158 fi &&
159 git commit -m "$1" &&
160 git tag "$1"
163 # Call test_merge with the arguments "<message> <commit>", where <commit>
164 # can be a tag pointing to the commit-to-merge.
166 test_merge () {
167 test_tick &&
168 git merge -m "$1" "$2" &&
169 git tag "$1"
172 # This function helps systems where core.filemode=false is set.
173 # Use it instead of plain 'chmod +x' to set or unset the executable bit
174 # of a file in the working directory and add it to the index.
176 test_chmod () {
177 chmod "$@" &&
178 git update-index --add "--chmod=$@"
181 # Unset a configuration variable, but don't fail if it doesn't exist.
182 test_unconfig () {
183 git config --unset-all "$@"
184 config_status=$?
185 case "$config_status" in
186 5) # ok, nothing to unset
187 config_status=0
189 esac
190 return $config_status
193 # Set git config, automatically unsetting it after the test is over.
194 test_config () {
195 test_when_finished "test_unconfig '$1'" &&
196 git config "$@"
199 test_config_global () {
200 test_when_finished "test_unconfig --global '$1'" &&
201 git config --global "$@"
204 write_script () {
206 echo "#!${2-"$SHELL_PATH"}" &&
208 } >"$1" &&
209 chmod +x "$1"
212 # Use test_set_prereq to tell that a particular prerequisite is available.
213 # The prerequisite can later be checked for in two ways:
215 # - Explicitly using test_have_prereq.
217 # - Implicitly by specifying the prerequisite tag in the calls to
218 # test_expect_{success,failure,code}.
220 # The single parameter is the prerequisite tag (a simple word, in all
221 # capital letters by convention).
223 test_set_prereq () {
224 satisfied_prereq="$satisfied_prereq$1 "
226 satisfied_prereq=" "
227 lazily_testable_prereq= lazily_tested_prereq=
229 # Usage: test_lazy_prereq PREREQ 'script'
230 test_lazy_prereq () {
231 lazily_testable_prereq="$lazily_testable_prereq$1 "
232 eval test_prereq_lazily_$1=\$2
235 test_run_lazy_prereq_ () {
236 script='
237 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
239 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
241 say >&3 "checking prerequisite: $1"
242 say >&3 "$script"
243 test_eval_ "$script"
244 eval_ret=$?
245 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
246 if test "$eval_ret" = 0; then
247 say >&3 "prerequisite $1 ok"
248 else
249 say >&3 "prerequisite $1 not satisfied"
251 return $eval_ret
254 test_have_prereq () {
255 # prerequisites can be concatenated with ','
256 save_IFS=$IFS
257 IFS=,
258 set -- $*
259 IFS=$save_IFS
261 total_prereq=0
262 ok_prereq=0
263 missing_prereq=
265 for prerequisite
267 case " $lazily_tested_prereq " in
268 *" $prerequisite "*)
271 case " $lazily_testable_prereq " in
272 *" $prerequisite "*)
273 eval "script=\$test_prereq_lazily_$prerequisite" &&
274 if test_run_lazy_prereq_ "$prerequisite" "$script"
275 then
276 test_set_prereq $prerequisite
278 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
279 esac
281 esac
283 total_prereq=$(($total_prereq + 1))
284 case "$satisfied_prereq" in
285 *" $prerequisite "*)
286 ok_prereq=$(($ok_prereq + 1))
289 # Keep a list of missing prerequisites
290 if test -z "$missing_prereq"
291 then
292 missing_prereq=$prerequisite
293 else
294 missing_prereq="$prerequisite,$missing_prereq"
296 esac
297 done
299 test $total_prereq = $ok_prereq
302 test_declared_prereq () {
303 case ",$test_prereq," in
304 *,$1,*)
305 return 0
307 esac
308 return 1
311 test_expect_failure () {
312 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
313 test "$#" = 2 ||
314 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
315 export test_prereq
316 if ! test_skip "$@"
317 then
318 say >&3 "checking known breakage: $2"
319 if test_run_ "$2" expecting_failure
320 then
321 test_known_broken_ok_ "$1"
322 else
323 test_known_broken_failure_ "$1"
326 echo >&3 ""
329 test_expect_success () {
330 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
331 test "$#" = 2 ||
332 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
333 export test_prereq
334 if ! test_skip "$@"
335 then
336 say >&3 "expecting success: $2"
337 if test_run_ "$2"
338 then
339 test_ok_ "$1"
340 else
341 test_failure_ "$@"
344 echo >&3 ""
347 # test_external runs external test scripts that provide continuous
348 # test output about their progress, and succeeds/fails on
349 # zero/non-zero exit code. It outputs the test output on stdout even
350 # in non-verbose mode, and announces the external script with "# run
351 # <n>: ..." before running it. When providing relative paths, keep in
352 # mind that all scripts run in "trash directory".
353 # Usage: test_external description command arguments...
354 # Example: test_external 'Perl API' perl ../path/to/test.pl
355 test_external () {
356 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
357 test "$#" = 3 ||
358 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
359 descr="$1"
360 shift
361 export test_prereq
362 if ! test_skip "$descr" "$@"
363 then
364 # Announce the script to reduce confusion about the
365 # test output that follows.
366 say_color "" "# run $test_count: $descr ($*)"
367 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
368 # to be able to use them in script
369 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
370 # Run command; redirect its stderr to &4 as in
371 # test_run_, but keep its stdout on our stdout even in
372 # non-verbose mode.
373 "$@" 2>&4
374 if [ "$?" = 0 ]
375 then
376 if test $test_external_has_tap -eq 0; then
377 test_ok_ "$descr"
378 else
379 say_color "" "# test_external test $descr was ok"
380 test_success=$(($test_success + 1))
382 else
383 if test $test_external_has_tap -eq 0; then
384 test_failure_ "$descr" "$@"
385 else
386 say_color error "# test_external test $descr failed: $@"
387 test_failure=$(($test_failure + 1))
393 # Like test_external, but in addition tests that the command generated
394 # no output on stderr.
395 test_external_without_stderr () {
396 # The temporary file has no (and must have no) security
397 # implications.
398 tmp=${TMPDIR:-/tmp}
399 stderr="$tmp/git-external-stderr.$$.tmp"
400 test_external "$@" 4> "$stderr"
401 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
402 descr="no stderr: $1"
403 shift
404 say >&3 "# expecting no stderr from previous command"
405 if [ ! -s "$stderr" ]; then
406 rm "$stderr"
408 if test $test_external_has_tap -eq 0; then
409 test_ok_ "$descr"
410 else
411 say_color "" "# test_external_without_stderr test $descr was ok"
412 test_success=$(($test_success + 1))
414 else
415 if [ "$verbose" = t ]; then
416 output=`echo; echo "# Stderr is:"; cat "$stderr"`
417 else
418 output=
420 # rm first in case test_failure exits.
421 rm "$stderr"
422 if test $test_external_has_tap -eq 0; then
423 test_failure_ "$descr" "$@" "$output"
424 else
425 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
426 test_failure=$(($test_failure + 1))
431 # debugging-friendly alternatives to "test [-f|-d|-e]"
432 # The commands test the existence or non-existence of $1. $2 can be
433 # given to provide a more precise diagnosis.
434 test_path_is_file () {
435 if ! [ -f "$1" ]
436 then
437 echo "File $1 doesn't exist. $*"
438 false
442 test_path_is_dir () {
443 if ! [ -d "$1" ]
444 then
445 echo "Directory $1 doesn't exist. $*"
446 false
450 test_path_is_missing () {
451 if [ -e "$1" ]
452 then
453 echo "Path exists:"
454 ls -ld "$1"
455 if [ $# -ge 1 ]; then
456 echo "$*"
458 false
462 # test_line_count checks that a file has the number of lines it
463 # ought to. For example:
465 # test_expect_success 'produce exactly one line of output' '
466 # do something >output &&
467 # test_line_count = 1 output
470 # is like "test $(wc -l <output) = 1" except that it passes the
471 # output through when the number of lines is wrong.
473 test_line_count () {
474 if test $# != 3
475 then
476 error "bug in the test script: not 3 parameters to test_line_count"
477 elif ! test $(wc -l <"$3") "$1" "$2"
478 then
479 echo "test_line_count: line count for $3 !$1 $2"
480 cat "$3"
481 return 1
485 # This is not among top-level (test_expect_success | test_expect_failure)
486 # but is a prefix that can be used in the test script, like:
488 # test_expect_success 'complain and die' '
489 # do something &&
490 # do something else &&
491 # test_must_fail git checkout ../outerspace
494 # Writing this as "! git checkout ../outerspace" is wrong, because
495 # the failure could be due to a segv. We want a controlled failure.
497 test_must_fail () {
498 "$@"
499 exit_code=$?
500 if test $exit_code = 0; then
501 echo >&2 "test_must_fail: command succeeded: $*"
502 return 1
503 elif test $exit_code -gt 129 -a $exit_code -le 192; then
504 echo >&2 "test_must_fail: died by signal: $*"
505 return 1
506 elif test $exit_code = 127; then
507 echo >&2 "test_must_fail: command not found: $*"
508 return 1
510 return 0
513 # Similar to test_must_fail, but tolerates success, too. This is
514 # meant to be used in contexts like:
516 # test_expect_success 'some command works without configuration' '
517 # test_might_fail git config --unset all.configuration &&
518 # do something
521 # Writing "git config --unset all.configuration || :" would be wrong,
522 # because we want to notice if it fails due to segv.
524 test_might_fail () {
525 "$@"
526 exit_code=$?
527 if test $exit_code -gt 129 -a $exit_code -le 192; then
528 echo >&2 "test_might_fail: died by signal: $*"
529 return 1
530 elif test $exit_code = 127; then
531 echo >&2 "test_might_fail: command not found: $*"
532 return 1
534 return 0
537 # Similar to test_must_fail and test_might_fail, but check that a
538 # given command exited with a given exit code. Meant to be used as:
540 # test_expect_success 'Merge with d/f conflicts' '
541 # test_expect_code 1 git merge "merge msg" B master
544 test_expect_code () {
545 want_code=$1
546 shift
547 "$@"
548 exit_code=$?
549 if test $exit_code = $want_code
550 then
551 return 0
554 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
555 return 1
558 # test_cmp is a helper function to compare actual and expected output.
559 # You can use it like:
561 # test_expect_success 'foo works' '
562 # echo expected >expected &&
563 # foo >actual &&
564 # test_cmp expected actual
567 # This could be written as either "cmp" or "diff -u", but:
568 # - cmp's output is not nearly as easy to read as diff -u
569 # - not all diff versions understand "-u"
571 test_cmp() {
572 $GIT_TEST_CMP "$@"
575 # Print a sequence of numbers or letters in increasing order. This is
576 # similar to GNU seq(1), but the latter might not be available
577 # everywhere (and does not do letters). It may be used like:
579 # for i in `test_seq 100`; do
580 # for j in `test_seq 10 20`; do
581 # for k in `test_seq a z`; do
582 # echo $i-$j-$k
583 # done
584 # done
585 # done
587 test_seq () {
588 case $# in
589 1) set 1 "$@" ;;
590 2) ;;
591 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
592 esac
593 "$PERL_PATH" -le 'print for $ARGV[0]..$ARGV[1]' -- "$@"
596 # This function can be used to schedule some commands to be run
597 # unconditionally at the end of the test to restore sanity:
599 # test_expect_success 'test core.capslock' '
600 # git config core.capslock true &&
601 # test_when_finished "git config --unset core.capslock" &&
602 # hello world
605 # That would be roughly equivalent to
607 # test_expect_success 'test core.capslock' '
608 # git config core.capslock true &&
609 # hello world
610 # git config --unset core.capslock
613 # except that the greeting and config --unset must both succeed for
614 # the test to pass.
616 # Note that under --immediate mode, no clean-up is done to help diagnose
617 # what went wrong.
619 test_when_finished () {
620 test_cleanup="{ $*
621 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
624 # Most tests can use the created repository, but some may need to create more.
625 # Usage: test_create_repo <directory>
626 test_create_repo () {
627 test "$#" = 1 ||
628 error "bug in the test script: not 1 parameter to test-create-repo"
629 repo="$1"
630 mkdir -p "$repo"
632 cd "$repo" || error "Cannot setup test environment"
633 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
634 error "cannot run git init -- have you built things yet?"
635 mv .git/hooks .git/hooks-disabled
636 ) || exit